Index: src/fl_read_image.cxx
===================================================================
--- src/fl_read_image.cxx	(Revision 11769)
+++ src/fl_read_image.cxx	(Arbeitskopie)
@@ -20,6 +20,8 @@
 #include <FL/Fl.H>
 #include <FL/fl_draw.H>
 #include "flstring.h"
+//#include <sys/time.h>
+//#include <math.h>
 
 #ifdef DEBUG
 #  include <stdio.h>
@@ -329,6 +331,56 @@
   // Allocate the image data array as needed...
   if (!p) p = new uchar[w * h * d];
 
+#if 1
+  // Speed up the most common conversion of
+  // RGB XImage d=3 and r/g/b values in full bytes,
+  // avoiding costly shift/multiply/divide operations
+  // => about 10x faster.
+  if (!image->red_mask &&
+      fl_visual->red_mask   == 0x00ff0000 &&
+      fl_visual->green_mask == 0x0000ff00 &&
+      fl_visual->blue_mask  == 0x000000ff &&
+      image->bits_per_pixel == 32) {
+
+//  timeval start, end;
+//  gettimeofday( &start, 0 );
+
+    pixel = (unsigned char *)image->data;
+    unsigned char *rgb = p;
+
+    if ( image->byte_order == LSBFirst ) {
+      for (y = 0; y < image->height; y ++) {
+        for (x = 0; x < image->width; x ++) {
+          *rgb++ = pixel[2];
+          *rgb++ = pixel[1];
+          *rgb++ = pixel[0];
+          pixel += 4;
+        }
+      }
+    }
+    else { // MSBFirst
+      for (y = 0; y < image->height; y ++) {
+        for (x = 0; x < image->width; x ++) {
+          *rgb++ = *pixel++;
+          *rgb++ = *pixel++;
+          *rgb++ = *pixel++;
+          pixel ++;
+        }
+      }
+    }
+
+//gettimeofday( &end, 0 );
+//printf( "copy XImage: %lu ms\n", lround( 0.001 * ((end.tv_sec-start.tv_sec) * 1000000 + (end.tv_usec-start.tv_usec)) ) );
+
+  // Destroy the X image we've read and return the RGB(A) image...
+  XDestroyImage(image);
+  return p;
+  }
+#endif
+
+//timeval start, end;
+//gettimeofday( &start, 0 );
+
   // Initialize the default colors/alpha in the whole image...
   memset(p, alpha, w * h * d);
 
@@ -620,6 +672,9 @@
     }
   }
 
+//gettimeofday( &end, 0 );
+//printf( "copy XImage: %lu ms\n", lround( 0.001 * ((end.tv_sec-start.tv_sec) * 1000000 + (end.tv_usec-start.tv_usec)) ) );
+
   // Destroy the X image we've read and return the RGB(A) image...
   XDestroyImage(image);
 
